#ifndef V4
#define V4

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

typedef struct
{
	size_t count;
	size_t capacity;
	float values[];
} stack;

/*
 * stack_init - loo uus pinu
 *  
 * count - algne reserveeritud suurus
 */
stack *stack_init(size_t count);

/*
 * stack_init - reserveeri piisavalt mälu vähemalt 'count' elemendi jaoks
 *  
 * s(in/out) - pinu
 * count - reserveeringu suurus
 */
void stack_reserve(stack **s, size_t count);

/*
 * stack_set - anna kohal 'i' väärtus 'value'
 *  
 * s(in/out) - pinu
 * i - väärtuse indeks
 * value - väärtus
 */
void stack_set(stack **s, size_t i, float value);

/*
 * ask_string - küsi sõne
 *  
 * message - sõnum, mida kasutajale kuvada
 * out - väljund
 * def - väljund, kui sisend oli tühi
 */
void ask_string(const char *message, char *out, const char *def);

/*
 * ask_float - küsi ujukoma arv
 *  
 * message - sõnum, mida kasutajale kuvada
 */
float ask_float(const char *message);

/*
 * test_file - ava fail, kui pole võimalik, siis hukku
 *  
 * name - failinimi
 * mode - režiim
 */
FILE *test_file(const char *name, const char *mode);

/*
 * read_file - loe faili sisu pinusse
 *  
 * f1 - avatud fail
 * s(in/out) - initsialiseeritud pinu
 */
void read_file(FILE *f1, stack **s);

/*
 * write_file - kirjuta pinu ja summa väljundfaili
 *  
 * f2 - avatud fail
 * H - väljundi väärtused
 * sum - arvutatud summa
 */
void write_file(FILE *f2, stack *H, float sum);

/*
 * calculate - arvuta H väärtused
 *  
 * A - pinu A
 * H(in/out) - pinu H, väljundi väärtused
 */
void calculate(stack *A, stack **H);

/*
 * calculate - kahe pinu skalaarkorrutise
 *  
 * A - pinu A
 * H - pinu H
 */
float get_sum(stack *A, stack *H);

#endif
